Subject: Re: [MacVLAN] failure to deliver reassembled IPv6 multicast traffic

From: Ben Greear <[email-masked]>
Date: Tue, 19 Feb 2013 14:47:52 -0800

On 02/19/2013 02:38 PM, Eric Dumazet wrote:
> On Tue, 2013-02-19 at 14:22 -0800, Ben Greear wrote:
>> On 02/15/2013 11:35 AM, Eric Dumazet wrote:
>>> On Fri, 2013-02-15 at 11:27 -0800, Ben Greear wrote:
>>>
>>>> For some reason I was thinking this wasn't fully fixed for IPv4, but
>>>> maybe it is..the bug in our internal tracker only mentions IPv6
>>>> as having issues...
>>>>
>>>> We'll do some testing on IPv4 sometime soon to make sure, and can test
>>>> IPv6 patches as well...
>>>
>>> This worries me a bit, as I wrote this patch because you reported the
>>> issue.
>>
>> We just did some testing on this on the 3.7.6+ kernel.  IPv4 multicast to
>> mac-vlans works OK with large packets if there is a single multicast receiver,
>> but does NOT work if there are multiple multicast receivers (ie, several
>> mac-vlans with an mcast receive bound to each mvlan).
>>
>> Our setup also involves routing rules and send-to-self rules,
>> with sender on the same machine, but I'm not sure that matters
>> too much or not.
>
> It might matter, because before commit 6d1ccff627806829c (net: reset mac
> header in dev_start_xmit() ), we were accessing wrong ethernet header in
> macvlan_broadcast() in the send-to-self path

I have that patch in my tree already, so it does not fix the
problem...  Also, I mos-spoke slightly...the test was on 3.7.9+
kernel...

Our test setup is not simple, and is driven by a proprietary
user-space application.  I can set it up on a system and
give you access if you want (you could investigate the
various routing rules, etc, to see how our config actually
happens).

Or, can help you install our app on your system and configure
it to cause this bug.  All these features should run fine on
standard upstream kernels.

There's no sane way for me to reproduce our test setup
with standard tools and mcast traffic generator/receivers,
however...

Thanks,
Ben

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com